//  Steven Kappes
//  MD2Model.h
//  Description: Class to load/draw models

#ifndef _MD2MODEL_
#define _MD2MODEL_

#include <stdlib.h>
#include <stdio.h>

class MD2Model
{
	public:
		MD2Model();
		MD2Model(char * mPath, char * tPath);
		~MD2Model();

		unsigned int frameCount(void);
		void render(unsigned int frame);
		void animate(unsigned int startFrame, unsigned int endFrame, float interpolate);
	private:
		void * modelData;
		char * texPath;

		void * getHeader(FILE * filePtr);
		void * getData(FILE * filePtr, void * headerData);
		void calculateNormal(float * f1, float * f2, float * f3);
		unsigned int readInt(FILE * filePtr);
		unsigned short readShort(FILE * filePtr);
		float readFloat(FILE * filePtr);
};

#endif