//  MoreBehaviors.h
//  Description: More behaviors for objects

#ifndef _MoreBehaviors_
#define _MoreBehaviors_

#include "GrObject.h"
#include "Behavior.h"
#include "MoreObjects.h"
#include "ParticleSystem.h"

class RotateBlades : public Behavior
{
	public:
		RotateBlades(GrObject* owner, float sp = 1.0f);
		virtual void simulateUntil(unsigned long);
	private:
		float speed;
};

class FlapWings : public Behavior
{
	public:
		FlapWings(GrObject* owner, float sp = 2.0f);
		virtual void simulateUntil(unsigned long);
	private:
		float speed;
};

class MoveForward : public Behavior
{
	public:
		MoveForward(GrObject* owner, float sp = 2.0f);
		virtual void simulateUntil(unsigned long);
	private:
		float speed;
};

class Turn : public Behavior
{
	public:
		Turn(GrObject* owner);
		virtual void simulateUntil(unsigned long);
};

class OgrosMove : public Behavior
{
	public:
		OgrosMove(GrObject* owner);
		virtual void simulateUntil(unsigned long);
};

class SnowStorm : public Behavior
{
	public:
		SnowStorm(GrObject * owner);
		virtual void simulateUntil(unsigned long);
};

#endif