//  MoreObjects.h
//  Description: More objects

#ifndef _MoreObjects_
#define _MoreObjects_

#include "GrObject.h"
#include "MD2Model.h"

class OgroField;

class Helicopter : public GrObject
{
	public:
		Helicopter();
		virtual void draw(DrawingState *);
		void setRotFactor(float deg);
	private:
		float degree;
};

class SubDivision2 : public GrObject
{
	public:
		SubDivision2();
		virtual void draw(DrawingState*);
		void updateOgroField(float time);
	private:
		OgroField * field;
};

class TennisCourt : public GrObject
{
	public:
		TennisCourt();
		virtual void draw(DrawingState *);
};

class Church2 : public GrObject
{
	public:
		Church2();
		virtual ~Church2();
		virtual void draw(DrawingState *);
		MD2Model * md2;
};

class Ogro : public GrObject
{
	public:
		Ogro(float x, float z);
		virtual ~Ogro();
		virtual void draw(DrawingState *);
		void changeState(void);
		void updateTime(float);
		void nextFrame(void);
		void rotate(float r);
		unsigned int state;
		unsigned int frame;
		float posX, posZ, rot;
		float interpolate;
};

class OgroField : public GrObject
{
	public:
		OgroField();
		virtual void draw(DrawingState *);
		void update(float time);
};

class Bird : public GrObject
{
	public:
		Bird();
		virtual void draw(DrawingState *);
		void update(float time);
		float rotAmt;
		bool moveUp;
};

#endif