//  ParticleSystem.h
//  Description: Particle system class

#ifndef _ParticleSystem_
#define _ParticleSystem_

#include "GrObject.h"
#include <vector>

using namespace std;

class Particle
{
	public:
		Particle();
		
		float pos[3];
		float vel[3];
		float accel[3];
		float size;
};

class ParticleSystem : public GrObject
{
	public:
		ParticleSystem(int mParticles, float height);
		~ParticleSystem();

		virtual void draw(DrawingState *);
		void update(unsigned long time);
		void emit(void);
		void addParticle(void);
	private:
		bool animate;
		float emissionHeight;
		unsigned int maxParticles;
		vector<Particle> particles;
};

#endif