#ifndef _SHADOWS_
#define _SHADOWS_

#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <vector>
#include <stdio.h>
using namespace std;

#include "MyVector.h"
#include "MMatrix.h"
#include "DrawingState.h"
#include "GrObject.h"

extern std::vector<GrObject *> shadowSpheres;

class ShadowSphere: public GrObject {
public:	
	inline ShadowSphere(float _x=0, float _y=0, float _z=0, float _r=0, float _rc=1, float _gc=1, float _bc=1)
		:	x(_x), y(_y), z(_z), r(_r), rc(_rc), gc(_gc), bc(_bc) {};
	float x, y, z, r, rc, gc, bc;
	virtual void draw(DrawingState * d);
	//void drawShadowVolumes();
	void drawShadowVolume(float lightPos[4], float infinity, float light_r=0);
};

//shapes
void DrawDisk(float r);
void DrawSphere(float r);
void DrawCylinder(float br, float tr, float h);

//shadow volumes
void drawShadowVolumes(float *);
void drawVolumetricShadows(float *);
void drawShadow();

//shadow mapping
void setShadowMapMatrix(GLfloat dest[16], float lightPos[4], float plane[4]);
void drawGroundPlane(float plane[4]);
void drawMappedShadows(float lightPos[4], float plane[4], DrawingState* drst);

#endif